(***********************************************************************)
(*                                                                     *)
(*          Run-time Code Generation Library for Objective Caml        *)
(*                                                                     *)
(*                   Dmitri Lomov (dsl@tepkom.ru)                      *)
(*              St-Petersburg State University, Russia                 *)
(*                                                                     *)
(***********************************************************************)    

(* $Header: /home/mitya/cvsroot/dml/bytecode/bytegen.mli,v 1.1.1.1 2002/02/28 11:11:01 mitya Exp $ *)
type codegen    (* Code generation state *)	

(* Initialization and termination *)

val init : unit -> unit 
val uninit : unit -> unit
val start : bool -> codegen
val stop : Bytecode.label -> codegen -> int

(* Bytecode *)
val instr : Bytecode.instruction -> codegen -> codegen
val getsp : codegen -> int
val setsp : int -> codegen -> codegen

val inline : RawBytecode.code_pointer -> int -> codegen -> codegen

(* Externals *)
val new_external : Obj.t -> codegen -> int * codegen

(* Labels *)
val newlabel : codegen -> Bytecode.label * codegen

val is_unsafe : codegen -> bool















