(***********************************************************************)
(*                                                                     *)
(*          Run-time Code Generation Library for Objective Caml        *)
(*                                                                     *)
(*                   Dmitri Lomov (dsl@tepkom.ru)                      *)
(*              St-Petersburg State University, Russia                 *)
(*                                                                     *)
(***********************************************************************)    

(* $Id: inliner.mli,v 1.1.1.1 2002/02/28 11:11:01 mitya Exp $ *)

type generator_state = Bytegen.codegen * GenHelper.t_generation_state
type generator = 
    GenHelper.any_code -> generator_state -> GenHelper.data_tag -> bool -> 
      generator_state

type inlining

(*
 * Performs an analysis of a given application for subsequent
 * inlining.
 * Params:
 *    code of function
 *    codes of params
 *    number of params
 * Returns:
 *    analysis result (if None, cannot inline)
 *    number of args to push on stack
 *    list of args to push on stack
 *)
val analyze : 
    GenHelper.any_code -> GenHelper.any_code list -> int ->
      inlining option * GenHelper.any_code list * int

val inline : inlining -> GenHelper.any_code list -> int -> 
  generator -> generator_state -> bool ->
  generator_state

