#!/bin/awk -f
#
# $Id: mli2tex.awk,v 1.2 2002/04/29 10:58:05 mitya Exp $
#


function trim(s)
{
    sub(/[[:blank:]]*/, "", s);
    return s
}

function specchars(s)
{
    gsub(/_/, "\\_", s);
#    gsub(/->/, "\\farr", s);
    return s;
}
function end_of_decl()
{
    if(decl) {
	print "\\end{caml-code}";
	print "\\nopagebreak[3]"
	decl = 0;
    }
}

function edit(txt)
{
    ibeg = index(txt, "(**");
    if(ibeg == 0) ibeg = -2;
    iend = index(txt, "**)");
    if(iend == 0) 
	txt = substr(txt, ibeg + 3);
    else
	txt = substr(txt, ibeg + 3, iend - ibeg - 3);
    txt = trim(txt);
    gsub(/\[/, "\\cd{", txt);
    gsub(/\]/, "}", txt);
    return specchars(txt);
}

BEGIN {
    matched = 0;
    decl = 0;
    firstComment = 1;
}

{ 
    matched = 0;
}

/^val/ { # $1 is a name, $4..end is the type}
    type = substr($0, index($0, ": ")+2);
    if(decl == 0) {
	print "\\noindent\\begin{caml-code}";
    }
    print "\\vl{" specchars($2) "}{" specchars(type) "}";
    decl = 1;
    matched = 1;
} 

/^type/ {
    if(decl == 0){
	print "\\noindent\\begin{caml-code}";
    }
    sub(/type/, "\\k{type}");

    print specchars(trim($0));    

    decl = 1;
    matched = 1;
}

/\(\*\+/ {
    end_of_decl();
    sub(/\(\*\+/, "");
    sub(/\+\*\)/, "");
    print "\\subsubsection{" $0 "}";
}

$0 == "" {
    end_of_decl();
    matched = 1;
}    
index($0, "(**") {
    if(!decl && !firstComment)
    {
	#print "\\par\\medskip\n\\noindent";
    }
    firstComment = 0;
}

index($0, "(**"), index($0, "**)") {
    end_of_decl()
    txt = $0;
    txt = edit(txt);
    print txt;
    decl = 0;
    matched = 1;
}

index($0, "**)") {
    print "\\par\\smallskip";
}

decl && !matched {
    print "\\>" specchars(trim($0))
}

#
# $Log: mli2tex.awk,v $
# Revision 1.2  2002/04/29 10:58:05  mitya
# *** empty log message ***
#
# Revision 1.1  2002/02/28 11:32:52  mitya
# Imported revision
#
#





